#!/usr/bin/env python3
# -*- coding: utf-8 -*-


import numpy as np
import matplotlib.pyplot as plt


# - - - - - - - - - - 1(d)(i) - - - - - - - - - - - - - - - - - - - - - 


l =  #use different values for lambda

Dt = #use different values for Dt

theta_1 =  #use the theta needed for (1.2)

theta_2 = #use the theta needed for (1.3)

T = #use the correct value for T

nstep = int(T/Dt)

t = np.linspace(0,T,nstep)

x = np.zeros(nstep)

x0 = # give the value of x(0)

x[0] = x0

tol = 1e-5


def f(t,x):
    return  #implement the function f as given in (1.4)


def sol(t):
    sl = []
    for time in t:
        sl.append( ) #implement the actual to (1.4) solution inside the parentheses
    return sl


def scheme_1_2(xk,tk,theta,f):
    """
    Here we implement the numerical scheme (1.2)
    
    Parameters
    ----------
    x_k : we give as input x^k
    t_k : we give as input t_k
    t_k1 : we give as input t_{k+1} 
    theta : we give as input the variable theta
    f : we give as input the function

    Returns the numerical scheme (1.2)

    """
    for i in range(len(t)-1):
        xk[i+1] = #complete the scheme (1.2)
    
    
    return xk


def EulerStep(f,y0,t0,theta,Dt):
    return #fill in the Euler step
 


def ImpEulerStep(f,x0,t0,Dt,theta,tol):

    
    # Initial estimate
    f0 = f(t0,x0)
    X1 = x0 + Dt*f0
    
    errNorm = np.linalg.norm(X1 - x0)
    
    # Fixed point iteration
    i = 0;
    while errNorm > Dt*tol:
        X1old = X1
        X1 =  # implement the step in (1.3)
        errNorm = np.linalg.norm(X1 - X1old)
        i = i+1
        if(i>=1e5):
            print('Fixed point iteration terminated after %d steps with error %g\n',i,errNorm)
            break
    
    # Define solution at next timestep
    x1 = X1
    
    return x1


def ImpMidPointSolveWithEuler(f,x0,t,Dt,theta,tol):

    x = np.zeros(nstep+1) # solution
    x[0] = x0 # set initial value
    
    # Compute solution
    for j in range(0,nstep):
        xhalf = #fill in here using the ImpEulerStep
        x[j+1] = #fill in here using the EulerStep
      
    return x


# - - - - - - - - - - 1(d)(ii) - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 


#You should plot the exact solution to (1.4) and the the schemes (1.2) and (1.3)
#in order to show the convergence property

